/*
	(C) 1995-96 AROS - The Amiga Research OS
	$Id: unlockibase.c,v 1.1.1.1 2005/03/15 15:54:21 laire Exp $
 
	Desc: Permits the access to all public fields of the IntuitionBase
	Lang: english
*/
#include <proto/exec.h>
#include "intuition_intern.h"

/*****************************************************************************
 
	NAME */
#include <proto/intuition.h>

AROS_LH1(void, UnlockIBase,

		 /*  SYNOPSIS */
		 AROS_LHA(ULONG, ibLock, A0),

		 /*  LOCATION */
		 struct IntuitionBase *, IntuitionBase, 70, Intuition)

/*  FUNCTION
	Release parts of Intuition which have been blocked with a prior
	call to LockIBase().
 
	INPUTS
	ibLock - The result of LockIBase().
 
	RESULT
	None.
 
	NOTES
 
	EXAMPLE
 
	BUGS
 
	SEE ALSO
	LockIBase()
 
	INTERNALS
 
	HISTORY
	29-10-95    digulla automatically created from
			    intuition_lib.fd and clib/intuition_protos.h
 
*****************************************************************************/
{
	AROS_LIBFUNC_INIT
	AROS_LIBBASE_EXT_DECL(struct IntuitionBase *,IntuitionBase)

	ibLock = ibLock;        /* shut up the compiler */

	#ifdef __MORPHOS__
	IBase->IBaseLockCount--;

	if (IBase->IBaseLockCount == 0)
	{
		IBase->IBaseLockTask = 0;
	}

	if (IBase->IBaseLockCount < 0)
	{
		dprintf("WARNING!: unmatched UnlockIBase call from task 0x%lx\n",(LONG)FindTask(0));
		IBase->IBaseLockCount = 0;
	}
	#endif

	ReleaseSemaphore (IBase->IBaseLock);

	AROS_LIBFUNC_EXIT
} /* UnlockIBase */
